import matplotlib.pyplot as plt
import pandas as pd
import numpy as np
from sklearn.model_selection import train_test_split
from sklearn.cluster import KMeans
from sklearn import tree
from sklearn import metrics
import datetime
import time




# Transform data into an internal datetime representation
def stringdate_to_datetime(stringdatetime : str):
    if "." in stringdatetime:
        stringdatetime=stringdatetime.split(".")[0]
    else:
        stringdatetime=stringdatetime.split("Z")[0]
    return datetime.datetime.fromtimestamp(time.mktime(time.strptime(stringdatetime, '%Y-%m-%dT%H:%M:%S')))


data1 = pd.read_csv('C:\pythonProjectsmarthouse\output_Window.csv', sep=',')
data1["datetime"] = data1["time"].apply(stringdate_to_datetime)

data2 = pd.read_csv('C:\pythonProjectsmarthouse\output_CO2.csv', sep=',')
data2["datetime"] = data2["time"].apply(stringdate_to_datetime)

data3 = pd.read_csv('C:\pythonProjectsmarthouse\output_Box_TV.csv', sep=',')
data3["datetime"] = data3["time"].apply(stringdate_to_datetime)

data4 = pd.read_csv('C:\pythonProjectsmarthouse\output_Bruit.csv', sep=',')
data4["datetime"] = data4["time"].apply(stringdate_to_datetime)

data5 = pd.read_csv('C:\pythonProjectsmarthouse\output_Humidite.csv', sep=',')
data5["datetime"] = data5["time"].apply(stringdate_to_datetime)

data6 = pd.read_csv('C:\pythonProjectsmarthouse\output_Luminosite.csv', sep=',')
data6["datetime"] = data6["time"].apply(stringdate_to_datetime)

data7 = pd.read_csv('C:\pythonProjectsmarthouse\output_Lumiere.csv', sep=',')
data7["datetime"] = data7["time"].apply(stringdate_to_datetime)

data8 = pd.read_csv('C:\pythonProjectsmarthouse\output_Temperature.csv', sep=',')
data8["datetime"] = data8["time"].apply(stringdate_to_datetime)

data9 = pd.read_csv('C:\pythonProjectsmarthouse\output_TV_Power.csv', sep=',')
data9["datetime"] = data9["time"].apply(stringdate_to_datetime)


data1.set_index('datetime', inplace=True)
print("isnull", data1.isnull().any())
data1.ffill()
newdata1 = data1.resample('30T').sum()
print(newdata1)


data2.set_index('datetime', inplace=True)
print("isnull", data2.isnull().any())
data2.ffill()
newdata2 = data2.resample('30T').sum()
print(newdata2)


data3.set_index('datetime', inplace=True)
print("isnull", data1.isnull().any())
data3.ffill()
newdata3 = data3.resample('30T').sum()
print(newdata3)


data4.set_index('datetime', inplace=True)
print("isnull", data4.isnull().any())
data4.ffill()
newdata4 = data4.resample('30T').sum()
print(newdata4)


data5.set_index('datetime', inplace=True)
print("isnull", data5.isnull().any())
data5.ffill()
newdata5 = data5.resample('30T').sum()
print(newdata5)


data6.set_index('datetime', inplace=True)
print("isnull", data6.isnull().any())
data6.ffill()
newdata6 = data6.resample('30T').sum()
print(newdata6)


data7.set_index('datetime', inplace=True)
print("isnull", data7.isnull().any())
data7.ffill()
newdata7 = data7.resample('30T').sum()
print(newdata7)


data8.set_index('datetime', inplace=True)
print("isnull", data8.isnull().any())
data8.ffill()
newdata8 = data8.resample('30T').sum()
print(newdata8)


data9.set_index('datetime', inplace=True)
print("isnull", data9.isnull().any())
data9.ffill()
newdata9 = data9.resample('30T').sum()
print(newdata9)




mergeData = [newdata1, newdata2, newdata3, newdata4, newdata5, newdata6, newdata7, newdata8, newdata9]
result = pd.concat(mergeData, axis=1, join='inner')
print(result)




# Waste energie
window = newdata1['Window']
co2 = newdata2['CO2']
for i in range(len (window)):
    if window[i] == 1 and co2[i] < 1000:
        print("we are wasting energy")
    elif window[i] == 1 and co2[i] >= 1000 or window[i] == 0 and co2[i] <= 1000:
        print("good")
    elif window[i] == 0 and co2[i] > 1000:
        print("we need to open window")




# Open heater
temperature = newdata8['Temperature']
humidity = newdata5['Humidite']
for i in range(len (temperature)):
    if temperature[i] < 15 and humidity[i] > 50:
        print("we need to open the heater")
    else:
        print("ok")     # tous les résultats sont "ok" car on est en été donc pas besoin d'ouvrir le chauffage




# Open lamp
luminosity = newdata6['Luminosite']
lamp = newdata7['Lumiere']
for i in range(len (lamp)):
    if lamp[i] == 1 and luminosity[i] > 55:
        print("we are wasting energy")
    elif lamp[i] == 1 and luminosity[i] <= 55 or lamp[i] == 0 and luminosity[i] >= 55:
        print("nice")
    elif window[i] == 0 and luminosity[i] < 55:
        print("we need to open lamp")




# Give values to the occupancy, but we didn't succeed
hours = range(0:00:00, 23:59:59, 30T)
data_datetime = pd.to_datetime(data.iloc[:,0], format='%d/%m/%Y %H:%M')
occupancy = []
if 5<=hours<=23:
    occupancy=1
else:
    occupancy=0

for dt in data_datetime:
    hours.append(dt.occupancy)
data['occupancy']=hours




######################################### the first exercise - Decision Tree ###########################################




# Lire fiche.csv
data = pd.read_csv ('C:\Users\guobi\Desktop\pythonProjectsmarthouse\pythonProjectsmarthouse\data.csv', sep=';')
print(data)




# Discritiez the labels to (0, 1)
newlabel=[]
label=data['label']

for n in range (len(label)):
    if ((type(label[n])) != int):

        if (label[n]<0.5):
            newlabel.append(0)
        else :
            newlabel.append(1)

data['newlabel']=newlabel




# Implement the DT
def  decision_tree(x_train,y_train,x_test,y_test):
    clf=tree.DecisionTreeClassifier(max_depth=9) #change max depth to 1,2 and see what the accurancy
    clf=clf.fit(x_train , y_train)
    y_test_pred=clf.predict(x_test)
    accuracy = clf.score(x_test, y_test) #Accurrancy
    print(accuracy)
    features_importance=clf.feature_importances_  #Important features
    print("features_importance"
          "",features_importance)

# Plot the features importance
    plt.figure(1)
    indices = np.argsort(features_importance)
    plt.title('Features Importance')
    plt.barh(range(len(indices)),features_importance[indices],color='b',align='center')
    plt.yticks(range(len(indices)),[x_train.columns.values[i] for i in indices])
    plt.xlabel('Relative Importance')

    #with open ("tree.dot",'w') as file :
        ##tree.export_graphiviz(clf,out_file=file)
    #print(metrics.classification_report(y_test,y_test_pred,target_names=['level 0','level 1']))
    #@return (y_test_pred)




# Test
x_train, x_test, y_train, y_test = train_test_split(data[["Tin","Tout","humidity","detected_motions","power","office_CO2_concentration","Door","CO2_corridor","acoustic_pressure_dB"]],
                                                    data[['newlabel']], test_size=0.3, random_state=2 )#70% of observations from our data will be used to train the model and rest 30% will be used to test the model
y_pred_occupancy= decision_tree(x_train, y_train, x_test, y_test)




# Plot the accuracy as a function of depth
plt.figure(2)
depth=[1,2,3,4,5,6,7,8,9]
accuracy=[0.987012987012987,0.987012987012987,0.9696969696969697,0.961038961038961,0.9653679653679653,0.9653679653679653,0.9653679653679653,0.961038961038961,0.9653679653679653]
plt.plot(depth,accuracy)
plt.show()











