import matplotlib.pyplot as plt
import pandas as pd
import numpy as np
from sklearn.model_selection import train_test_split
from sklearn.cluster import KMeans
from sklearn import tree
from sklearn import metrics
import datetime
import time




# Lire fiche.csv
data = pd.read_csv ('/Users/amayrim/Downloads/g11/data.csv', sep=';')
print(data)


# Discritiez the labels to (0, 1)
newlabel=[]
label=data['label']
for n in range (len(label)):
    if ((type(label[n])) != int):

        if (label[n]<0.5):
            newlabel.append(0)
        else :
            newlabel.append(1)

data['newlabel']=newlabel

#Implement the DT
#DT
def  decision_tree(x_train,y_train,x_test,y_test):
    clf=tree.DecisionTreeClassifier(max_depth=9) #change max depth to 1,2 and see what the accurancy
    clf=clf.fit(x_train , y_train)
    y_test_pred=clf.predict(x_test)
    accuracy = clf.score(x_test, y_test) #Accurrancy
    print(accuracy)
    features_importance=clf.feature_importances_  #Important features
    print("features_importance"
          "",features_importance)

#plot the features importance
    plt.figure(1)
    indices = np.argsort(features_importance)
    plt.title('Features Importance')
    plt.barh(range(len(indices)),features_importance[indices],color='b',align='center')
    plt.yticks(range(len(indices)),[x_train.columns.values[i] for i in indices])
    plt.xlabel('Relative Importance')
    #with open ("tree.dot",'w') as file :
        ##tree.export_graphiviz(clf,out_file=file)
    #print(metrics.classification_report(y_test,y_test_pred,target_names=['level 0','level 1']))
    #@return (y_test_pred)
#test
x_train, x_test, y_train, y_test = train_test_split(data[["Tin","Tout","humidity","detected_motions","power","office_CO2_concentration","Door","CO2_corridor","acoustic_pressure_dB"]],
                                                    data[['newlabel']], test_size=0.3, random_state=0 )#70% of observations from our data will be used to train the model and rest 30% will be used to test the model
y_pred_occupancy= decision_tree(x_train, y_train, x_test, y_test)

#plot the tree

plt.figure(2)
depth=[1,2,3,4,5,6,7,8,9]
accuracy=[0.987012987012987,0.987012987012987,0.9696969696969697,0.961038961038961,0.9653679653679653,0.9653679653679653,0.9653679653679653,0.961038961038961,0.9653679653679653]
plt.plot(depth,accuracy)
plt.show()